Index: /LMDZ5/trunk/libf/phylmd/phys_output_write.h
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_output_write.h	(revision 1538)
+++ /LMDZ5/trunk/libf/phylmd/phys_output_write.h	(revision 1539)
@@ -1177,68 +1383,118 @@
 
        IF (o_lwcon%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_lwcon%name,itau_w,flwc)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_lwcon%name,itau_w,flwc)
        ENDIF
 
        IF (o_iwcon%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_iwcon%name,itau_w,fiwc)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_iwcon%name,itau_w,fiwc)
        ENDIF
 
        IF (o_temp%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_temp%name,itau_w,t_seri)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_temp%name,itau_w,t_seri)
        ENDIF
 
        IF (o_theta%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_theta%name,itau_w,theta)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_theta%name,itau_w,theta)
        ENDIF
 
        IF (o_ovapinit%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_ovapinit%name,itau_w,
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_ovapinit%name,itau_w,
      $ qx(:,:,ivap))
        ENDIF
 
        IF (o_ovap%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
      $                   o_ovap%name,itau_w,q_seri)
        ENDIF
 
        IF (o_geop%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_geop%name,itau_w,zphi)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_geop%name,itau_w,zphi)
        ENDIF
 
        IF (o_vitu%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_vitu%name,itau_w,u_seri)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_vitu%name,itau_w,u_seri)
        ENDIF
 
        IF (o_vitv%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_vitv%name,itau_w,v_seri)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_vitv%name,itau_w,v_seri)
        ENDIF
 
        IF (o_vitw%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_vitw%name,itau_w,omega)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_vitw%name,itau_w,omega)
        ENDIF
 
         IF (o_pres%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_pres%name,itau_w,pplay)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_pres%name,itau_w,pplay)
         ENDIF
 
         IF (o_paprs%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_paprs%name,
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_paprs%name,
      s                    itau_w,paprs(:,1:klev))
         ENDIF
 
+        IF (o_zfull%flag(iff)<=lev_files(iff)) THEN
+         DO i=1, klon
+          zx_tmp_fi3d1(i,1)= pphis(i)/RG
+!020611   zx_tmp_fi3d(i,1)= pphis(i)/RG
+         ENDDO
+         DO k=1, klev
+!020611        DO k=1, klev-1
+         DO i=1, klon
+!020611         zx_tmp_fi3d(i,k+1)= zx_tmp_fi3d(i,k) - (t_seri(i,k) *RD * 
+          zx_tmp_fi3d1(i,k+1)= zx_tmp_fi3d1(i,k) - (t_seri(i,k) *RD * 
+     $    (paprs(i,k+1) - paprs(i,k))) / ( pplay(i,k) * RG ) 
+         ENDDO
+         ENDDO
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_zfull%name,itau_w,zx_tmp_fi3d1(:,2:klevp1))
+!020611    $o_zfull%name,itau_w,zx_tmp_fi3d)
+        ENDIF
+
+        IF (o_zhalf%flag(iff)<=lev_files(iff)) THEN
+         DO i=1, klon
+          zx_tmp_fi3d(i,1)= pphis(i)/RG - (
+     $    (t_seri(i,1)+zxtsol(i))/2. *RD *
+     $    (pplay(i,1) - paprs(i,1)))/( (paprs(i,1)+pplay(i,1))/2. * RG)
+         ENDDO
+         DO k=1, klev-1
+         DO i=1, klon
+          zx_tmp_fi3d(i,k+1)= zx_tmp_fi3d(i,k) - (
+     $    (t_seri(i,k)+t_seri(i,k+1))/2. *RD * 
+     $    (pplay(i,k+1) - pplay(i,k))) / ( paprs(i,k) * RG ) 
+         ENDDO
+         ENDDO
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_zhalf%name,itau_w,zx_tmp_fi3d)
+        ENDIF
+
        IF (o_rneb%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_rneb%name,itau_w,cldfra)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rneb%name,itau_w,cldfra)
        ENDIF
 
        IF (o_rnebcon%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_rnebcon%name,itau_w,rnebcon)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rnebcon%name,itau_w,rnebcon)
        ENDIF
 
        IF (o_rhum%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_rhum%name,itau_w,zx_rh)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_rhum%name,itau_w,zx_rh)
        ENDIF
 
       IF (o_ozone%flag(iff)<=lev_files(iff)) THEN
-         CALL histwrite_phy(nid_files(iff), o_ozone%name, itau_w,
+         CALL histwrite_phy(nid_files(iff),clef_stations(iff), 
+     $o_ozone%name, itau_w,
      $        wo(:, :, 1) * dobson_u * 1e3 / zmasse / rmo3 * rmd)
       ENDIF
@@ -1246,14 +1502,16 @@
       IF (o_ozone_light%flag(iff)<=lev_files(iff) .and.
      $     read_climoz == 2) THEN
-         CALL histwrite_phy(nid_files(iff), o_ozone_light%name, itau_w,
+         CALL histwrite_phy(nid_files(iff),clef_stations(iff), 
+     $o_ozone_light%name, itau_w,
      $        wo(:, :, 2) * dobson_u * 1e3 / zmasse / rmo3 * rmd)
       ENDIF
 
        IF (o_dtphy%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_dtphy%name,itau_w,d_t)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtphy%name,itau_w,d_t)
        ENDIF
 
        IF (o_dqphy%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
      s                  o_dqphy%name,itau_w, d_qx(:,:,ivap))
        ENDIF
@@ -1262,5 +1520,5 @@
         IF (o_albe_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN 
         zx_tmp_fi2d(1 : klon) = falb1( 1 : klon, nsrf)
-        CALL histwrite_phy(nid_files(iff),
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
      s                    o_albe_srf(nsrf)%name,itau_w,
      $                     zx_tmp_fi2d)
@@ -1269,5 +1527,5 @@
         IF (o_rugs_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN  
         zx_tmp_fi2d(1 : klon) = frugs( 1 : klon, nsrf)
-        CALL histwrite_phy(nid_files(iff),
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
      s                     o_rugs_srf(nsrf)%name,itau_w,
      $      zx_tmp_fi2d)
@@ -1276,5 +1534,5 @@
         IF (o_ages_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
         zx_tmp_fi2d(1 : klon) = agesno( 1 : klon, nsrf)
-        CALL histwrite_phy(nid_files(iff),
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
      s                     o_ages_srf(nsrf)%name,itau_w
      $    ,zx_tmp_fi2d)
@@ -1283,9 +1541,11 @@
 
        IF (o_alb1%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_alb1%name,itau_w,albsol1)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_alb1%name,itau_w,albsol1)
        ENDIF
 
        IF (o_alb2%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_alb2%name,itau_w,albsol2)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_alb2%name,itau_w,albsol2)
        ENDIF
 
@@ -1300,59 +1560,108 @@
       enddo
        IF (o_tke%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_tke%name,itau_w,zx_tmp_fi3d)
-       ENDIF
-
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_tke%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+      IF (.NOT.clef_stations(iff)) THEN
        IF (o_tke_max%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
      s                   o_tke_max%name,itau_w,zx_tmp_fi3d)
        ENDIF
+      ENDIF
       endif
 
        IF (o_kz%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_kz%name,itau_w,coefh)
-       ENDIF
-
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_kz%name,itau_w,coefh)
+       ENDIF
+
+      IF (.NOT.clef_stations(iff)) THEN
        IF (o_kz_max%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_kz_max%name,itau_w,coefh)
-       ENDIF
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_kz_max%name,itau_w,coefh)
+       ENDIF
+      ENDIF
 
        IF (o_clwcon%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_clwcon%name,itau_w,clwcon0)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_clwcon%name,itau_w,clwcon0)
        ENDIF
 
        IF (o_dtdyn%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_dtdyn%name,itau_w,d_t_dyn)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtdyn%name,itau_w,d_t_dyn)
        ENDIF
 
        IF (o_dqdyn%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_dqdyn%name,itau_w,d_q_dyn)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dqdyn%name,itau_w,d_q_dyn)
        ENDIF
 
        IF (o_dudyn%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_dudyn%name,itau_w,d_u_dyn)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dudyn%name,itau_w,d_u_dyn)
        ENDIF                                                    
 
        IF (o_dvdyn%flag(iff)<=lev_files(iff)) THEN                 
-      CALL histwrite_phy(nid_files(iff),o_dvdyn%name,itau_w,d_v_dyn)  
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dvdyn%name,itau_w,d_v_dyn)  
        ENDIF                                                     
 
        IF (o_dtcon%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_t_con(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dtcon%name,itau_w,zx_tmp_fi3d)
-       ENDIF
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtcon%name,itau_w,zx_tmp_fi3d)
+      ENDIF                                                     
+
+      if(iflag_thermals.eq.1)then
+      IF (o_tntc%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=d_t_con(1:klon,1:klev)/pdtphys +
+     $                           d_t_ajsb(1:klon,1:klev)/pdtphys
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_tntc%name,itau_w,zx_tmp_fi3d)
+      ENDIF
+      else if(iflag_thermals.gt.1.and.iflag_wake.EQ.1)then
+      IF (o_tntc%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=d_t_con(1:klon,1:klev)/pdtphys +
+     $                           d_t_ajs(1:klon,1:klev)/pdtphys +
+     $                           d_t_wake(1:klon,1:klev)/pdtphys
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_tntc%name,itau_w,zx_tmp_fi3d)
+      ENDIF
+      endif
 
        IF (o_ducon%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_u_con(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_ducon%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_ducon%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (o_dqcon%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_q_con(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dqcon%name,itau_w,zx_tmp_fi3d)
-       ENDIF
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dqcon%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+
+      if(iflag_thermals.eq.1)then
+       IF (o_tnhusc%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=d_q_con(1:klon,1:klev)/pdtphys
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_tnhusc%name,itau_w,zx_tmp_fi3d)
+       ENDIF
+      else if(iflag_thermals.gt.1.and.iflag_wake.EQ.1)then
+      IF (o_tnhusc%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=d_q_con(1:klon,1:klev)/pdtphys +
+     $                           d_q_ajs(1:klon,1:klev)/pdtphys +
+     $                           d_q_wake(1:klon,1:klev)/pdtphys
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_tnhusc%name,itau_w,zx_tmp_fi3d)
+      ENDIF
+      endif
 
        IF (o_dtlsc%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_t_lsc(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dtlsc%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtlsc%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
@@ -1360,5 +1669,5 @@
       zx_tmp_fi3d(1:klon, 1:klev)=(d_t_lsc(1:klon,1:klev)+
      $                           d_t_eva(1:klon,1:klev))/pdtphys
-      CALL histwrite_phy(nid_files(iff),
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
      s                   o_dtlschr%name,itau_w,zx_tmp_fi3d)
        ENDIF
@@ -1366,5 +1675,6 @@
        IF (o_dqlsc%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_q_lsc(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dqlsc%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dqlsc%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
@@ -1376,5 +1686,6 @@
       zx_tmp_fi3d(1:klon,1:klev)=d_t_lscth(1:klon,1:klev)/pdtphys
       CALL 
-     s histwrite_phy(nid_files(iff),o_dtlscth%name,itau_w,zx_tmp_fi3d)
+     s histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtlscth%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
@@ -1382,5 +1693,6 @@
       zx_tmp_fi3d(1:klon,1:klev)=d_t_lscst(1:klon,1:klev)/pdtphys
       CALL 
-     s histwrite_phy(nid_files(iff),o_dtlscst%name,itau_w,zx_tmp_fi3d)
+     s histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtlscst%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
@@ -1388,5 +1700,6 @@
       zx_tmp_fi3d(1:klon,1:klev)=d_q_lscth(1:klon,1:klev)/pdtphys
       CALL 
-     s histwrite_phy(nid_files(iff),o_dqlscth%name,itau_w,zx_tmp_fi3d)
+     s histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dqlscth%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
@@ -1394,13 +1707,16 @@
       zx_tmp_fi3d(1:klon,1:klev)=d_q_lscst(1:klon,1:klev)/pdtphys
       CALL 
-     s histwrite_phy(nid_files(iff),o_dqlscst%name,itau_w,zx_tmp_fi3d)
+     s histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dqlscst%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (o_plulth%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_plulth%name,itau_w,plul_th)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_plulth%name,itau_w,plul_th)
        ENDIF
 
        IF (o_plulst%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_plulst%name,itau_w,plul_st)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_plulst%name,itau_w,plul_st)
        ENDIF
 
@@ -1416,5 +1732,6 @@
        IF (o_ptconvth%flag(iff)<=lev_files(iff)) THEN
       CALL 
-     s  histwrite_phy(nid_files(iff),o_ptconvth%name,itau_w,zx_tmp_fi3d)
+     s  histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_ptconvth%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
@@ -1424,5 +1741,6 @@
        IF (o_ptconvth%flag(iff)<=lev_files(iff)) THEN
       CALL 
-     s histwrite_phy(nid_files(iff),o_lmaxth%name,itau_w,zx_tmp_fi2d)
+     s histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_lmaxth%name,itau_w,zx_tmp_fi2d)
        ENDIF
 
@@ -1433,20 +1751,24 @@
        IF (o_dtvdf%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_t_vdf(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dtvdf%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtvdf%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (o_dqvdf%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_q_vdf(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dqvdf%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dqvdf%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (o_dteva%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_t_eva(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dteva%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dteva%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (o_dqeva%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_q_eva(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dqeva%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dqeva%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
@@ -1454,14 +1776,18 @@
       zpt_conv = 0.
       where (ptconv) zpt_conv = 1.
-      CALL histwrite_phy(nid_files(iff),o_ptconv%name,itau_w,zpt_conv)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_ptconv%name,itau_w,zpt_conv)
        ENDIF
 
        IF (o_ratqs%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_ratqs%name,itau_w,ratqs)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_ratqs%name,itau_w,ratqs)
        ENDIF
 
        IF (o_dtthe%flag(iff)<=lev_files(iff)) THEN
-      zx_tmp_fi3d(1:klon,1:klev)=d_t_ajs(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dtthe%name,itau_w,zx_tmp_fi3d)
+      zx_tmp_fi3d(1:klon,1:klev)=d_t_ajs(1:klon,1:klev)/pdtphys -
+     $                           d_t_ajsb(1:klon,1:klev)/pdtphys
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtthe%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
@@ -1470,49 +1796,59 @@
 ! Pour l instant 0 a y reflichir pour les thermiques
          zx_tmp_fi2d=0. 
-        CALL histwrite_phy(nid_files(iff),o_ftime_th%name,
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_ftime_th%name,
      s                     itau_w,zx_tmp_fi2d)
         ENDIF
 
         IF (o_f_th%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_f_th%name,itau_w,fm_therm)
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_f_th%name,itau_w,fm_therm)
         ENDIF
 
         IF (o_e_th%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_e_th%name,itau_w,entr_therm)
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_e_th%name,itau_w,entr_therm)
         ENDIF
 
         IF (o_w_th%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_w_th%name,itau_w,zw2)
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_w_th%name,itau_w,zw2)
         ENDIF
 
         IF (o_q_th%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_q_th%name,itau_w,zqasc)
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_q_th%name,itau_w,zqasc)
         ENDIF
 
         IF (o_lambda_th%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
      s                     o_lambda_th%name,itau_w,lambda_th)
         ENDIF
 
         IF (o_a_th%flag(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),o_a_th%name,itau_w,fraca)
+        CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_a_th%name,itau_w,fraca)
         ENDIF
 
        IF (o_d_th%flag(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),o_d_th%name,itau_w,detr_therm)
-       ENDIF
-
+       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_d_th%name,itau_w,detr_therm)
+       ENDIF
 
        IF (o_f0_th%flag(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),o_f0_th%name,itau_w,f0)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_f0_th%name,itau_w,f0)
        ENDIF
 
        IF (o_zmax_th%flag(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),o_zmax_th%name,itau_w,zmax_th)
+       CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_zmax_th%name,itau_w,zmax_th)
        ENDIF
 
        IF (o_dqthe%flag(iff)<=lev_files(iff)) THEN
-      zx_tmp_fi3d(1:klon,1:klev)=d_q_ajs(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dqthe%name,itau_w,zx_tmp_fi3d)
+      zx_tmp_fi3d(1:klon,1:klev)=d_q_ajs(1:klon,1:klev)/pdtphys -
+     $                           d_q_ajsb(1:klon,1:klev)/pdtphys
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dqthe%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
@@ -1521,45 +1857,54 @@
        IF (o_dtajs%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_t_ajsb(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dtajs%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtajs%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (o_dqajs%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_q_ajsb(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dqajs%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dqajs%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (o_dtswr%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=heat(1:klon,1:klev)/RDAY
-      CALL histwrite_phy(nid_files(iff),o_dtswr%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtswr%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (o_dtsw0%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=heat0(1:klon,1:klev)/RDAY
-      CALL histwrite_phy(nid_files(iff),o_dtsw0%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtsw0%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (o_dtlwr%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=-1.*cool(1:klon,1:klev)/RDAY
-      CALL histwrite_phy(nid_files(iff),o_dtlwr%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtlwr%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (o_dtlw0%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=-1.*cool0(1:klon,1:klev)/RDAY
-      CALL histwrite_phy(nid_files(iff),o_dtlw0%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtlw0%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (o_dtec%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_t_ec(1:klon,1:klev)
-      CALL histwrite_phy(nid_files(iff),o_dtec%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtec%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (o_duvdf%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_u_vdf(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_duvdf%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_duvdf%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
        IF (o_dvvdf%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_v_vdf(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dvvdf%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dvvdf%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
@@ -1567,10 +1912,18 @@
       IF (o_duoro%flag(iff)<=lev_files(iff)) THEN 
       zx_tmp_fi3d(1:klon,1:klev)=d_u_oro(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_duoro%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_duoro%name,itau_w,zx_tmp_fi3d)
        ENDIF
 
       IF (o_dvoro%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi3d(1:klon,1:klev)=d_v_oro(1:klon,1:klev)/pdtphys
-      CALL histwrite_phy(nid_files(iff),o_dvoro%name,itau_w,zx_tmp_fi3d)
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dvoro%name,itau_w,zx_tmp_fi3d)
+      ENDIF
+
+      IF (o_dtoro%flag(iff)<=lev_files(iff)) THEN
+      zx_tmp_fi3d(1:klon,1:klev)=d_t_oro(1:klon,1:klev)/pdtphys
+      CALL histwrite_phy(nid_files(iff),clef_stations(iff),
+     $o_dtoro%name,itau_w,zx_tmp_fi3d)
       ENDIF
        ENDIF
